import { useTaroMemo } from '@tarojs/taro';
import useToggle from '../useToggle';
export default function useBoolean(defaultValue) {
  if (defaultValue === void 0) {
    defaultValue = false;
  }

  var _useToggle = useToggle(defaultValue),
      state = _useToggle[0],
      _useToggle$ = _useToggle[1],
      toggle = _useToggle$.toggle,
      _set = _useToggle$.set;

  var actions = useTaroMemo(function () {
    var setTrue = function setTrue() {
      return _set(true);
    };

    var setFalse = function setFalse() {
      return _set(false);
    };

    return {
      toggle: toggle,
      set: function set(v) {
        return _set(!!v);
      },
      setTrue: setTrue,
      setFalse: setFalse
    };
  }, []);
  return [state, actions];
}