import { useTaroEffect, useTaroState } from '@tarojs/taro';
import { escapeState } from '@taro-hooks/shared';
import useDebounceFn from '../useDebounceFn';

function useDebounce(value, options) {
  var _useTaroState = useTaroState(value),
      debounced = _useTaroState[0],
      setDebounced = _useTaroState[1];

  var debounceFn = useDebounceFn(function () {
    setDebounced(value);
  }, options);
  useTaroEffect(function () {
    escapeState(debounceFn).run();
  }, [value]);
  return debounced;
}

export default useDebounce;