import { useTaroEffect } from '@tarojs/taro';
import { isFunction } from '@taro-hooks/shared';

var useMount = function useMount(fn) {
  if (process.env.NODE_ENV === 'development') {
    if (!isFunction(fn)) {
      console.error("useMount: parameter `fn` expected to be a function, but got \"" + typeof fn + "\".");
    }
  }

  useTaroEffect(function () {
    fn == null ? void 0 : fn();
  }, []);
};

export default useMount;