import { useTaroEffect, useTaroState } from '@tarojs/taro';
import { escapeState } from '@taro-hooks/shared';
import useThrottleFn from '../useThrottleFn';

function useThrottle(value, options) {
  var _useTaroState = useTaroState(value),
      throttled = _useTaroState[0],
      setThrottled = _useTaroState[1];

  var throttleFn = useThrottleFn(function () {
    setThrottled(value);
  }, options);
  useTaroEffect(function () {
    escapeState(throttleFn).run();
  }, [value]);
  return throttled;
}

export default useThrottle;