import { useTaroEffect } from '@tarojs/taro';
import useLatest from '../useLatest';
import { isFunction } from '@taro-hooks/shared';

var useUnmount = function useUnmount(fn) {
  if (process.env.NODE_ENV === 'development') {
    if (!isFunction(fn)) {
      console.error("useUnmount expected parameter is a function, got " + typeof fn);
    }
  }

  var fnRef = useLatest(fn);
  useTaroEffect(function () {
    return function () {
      fnRef.current();
    };
  }, []);
};

export default useUnmount;