"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createUpdateEffect = void 0;

var taro_1 = require("@tarojs/taro");

var createUpdateEffect = function createUpdateEffect(hook) {
  return function (effect, deps) {
    var isMounted = (0, taro_1.useTaroRef)(false); // for react-refresh

    hook(function () {
      return function () {
        isMounted.current = false;
      };
    }, []);
    hook(function () {
      if (!isMounted.current) {
        isMounted.current = true;
      } else {
        return effect();
      }
    }, deps);
  };
};

exports.createUpdateEffect = createUpdateEffect;