"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var tslib_1 = require("tslib");

var taro_1 = require("@tarojs/taro");

var useToggle_1 = tslib_1.__importDefault(require("../useToggle"));

function useBoolean(defaultValue) {
  if (defaultValue === void 0) {
    defaultValue = false;
  }

  var _ref = (0, useToggle_1["default"])(defaultValue),
      state = _ref[0],
      _ref$ = _ref[1],
      toggle = _ref$.toggle,
      _set = _ref$.set;

  var actions = (0, taro_1.useTaroMemo)(function () {
    var setTrue = function setTrue() {
      return _set(true);
    };

    var setFalse = function setFalse() {
      return _set(false);
    };

    return {
      toggle: toggle,
      set: function set(v) {
        return _set(!!v);
      },
      setTrue: setTrue,
      setFalse: setFalse
    };
  }, []);
  return [state, actions];
}

exports["default"] = useBoolean;