"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var tslib_1 = require("tslib");

var taro_1 = require("@tarojs/taro");

var shared_1 = require("@taro-hooks/shared");

var useDebounceFn_1 = tslib_1.__importDefault(require("../useDebounceFn"));

function useDebounce(value, options) {
  var _ref = (0, taro_1.useTaroState)(value),
      debounced = _ref[0],
      setDebounced = _ref[1];

  var debounceFn = (0, useDebounceFn_1["default"])(function () {
    setDebounced(value);
  }, options);
  (0, taro_1.useTaroEffect)(function () {
    (0, shared_1.escapeState)(debounceFn).run();
  }, [value]);
  return debounced;
}

exports["default"] = useDebounce;