"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var tslib_1 = require("tslib");

var lodash_wechat_1 = require("lodash-wechat");

var taro_1 = require("@tarojs/taro");

var useLatest_1 = tslib_1.__importDefault(require("../useLatest"));

var useUnmount_1 = tslib_1.__importDefault(require("../useUnmount"));

function useDebounceFn(fn, options) {
  var _options$wait;

  if (process.env.NODE_ENV === 'development') {
    if (typeof fn !== 'function') {
      console.error("useDebounceFn expected parameter is a function, got " + typeof fn);
    }
  }

  var fnRef = (0, useLatest_1["default"])(fn);
  var wait = (_options$wait = options == null ? void 0 : options.wait) != null ? _options$wait : 1000;
  var debounced = (0, taro_1.useTaroMemo)(function () {
    return (// @ts-ignore
      (0, lodash_wechat_1.debounce)(function () {
        return fnRef.current.apply(fnRef, arguments);
      }, wait, options)
    );
  }, []);
  (0, useUnmount_1["default"])(function () {
    // @ts-ignore
    debounced.cancel();
  });
  return {
    run: debounced,
    // @ts-ignore
    cancel: debounced.cancel,
    // @ts-ignore
    flush: debounced.flush
  };
}

exports["default"] = useDebounceFn;