"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var taro_1 = require("@tarojs/taro");

var shared_1 = require("@taro-hooks/shared");

function useMemoizedFn(fn) {
  if (process.env.NODE_ENV === 'development') {
    if (!(0, shared_1.isFunction)(fn)) {
      console.error("useMemoizedFn expected parameter is a function, got " + typeof fn);
    }
  }

  var fnRef = (0, taro_1.useTaroRef)(fn); // why not write `fnRef.current = fn`?
  // https://github.com/alibaba/hooks/issues/728

  fnRef.current = (0, taro_1.useTaroMemo)(function () {
    return fn;
  }, [fn]);
  var memoizedFn = (0, taro_1.useTaroRef)();

  if (!memoizedFn.current) {
    memoizedFn.current = function () {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return fnRef.current.apply(this, args);
    };
  }

  return memoizedFn.current;
}

exports["default"] = useMemoizedFn;