"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var tslib_1 = require("tslib");

var taro_1 = require("@tarojs/taro");

var useLatest_1 = tslib_1.__importDefault(require("../useLatest"));

var shared_1 = require("@taro-hooks/shared");

var useUnmount = function useUnmount(fn) {
  if (process.env.NODE_ENV === 'development') {
    if (!(0, shared_1.isFunction)(fn)) {
      console.error("useUnmount expected parameter is a function, got " + typeof fn);
    }
  }

  var fnRef = (0, useLatest_1["default"])(fn);
  (0, taro_1.useTaroEffect)(function () {
    return function () {
      fnRef.current();
    };
  }, []);
};

exports["default"] = useUnmount;